-- complain if script is sourced in psql
-- rather than via CREATE EXTENSION
\echo USE "CREATE EXTENSION cc_sql" TO LOAD this file. \quit


CREATE FUNCTION cc_destination_in(cstring) RETURNS cc_destination
     AS 'MODULE_PATHNAME', 'cc_destination_in'
     LANGUAGE C IMMUTABLE STRICT;

CREATE FUNCTION cc_destination_out(cc_destination) RETURNS cstring
    AS 'MODULE_PATHNAME', 'cc_destination_out'
    LANGUAGE C IMMUTABLE STRICT;

CREATE TYPE cc_destination (
  internallength = 24,
  input          = cc_destination_in,
  output         = cc_destination_out
) ;

create type cc_sys_distribute_resource as
(
    resource_id bigint,
    limit_items integer
);

create type cc_sys_distribute_type as
(
    type_id     bigint,
    resource_id bigint,
    offsets     smallint[]
);


create type cc_sys_distribute_request as
(
    queue_id   integer,
    bucket_id  integer,
    queue_type integer,
    epoch_time bigint,
    timezones  smallint[],
    ratio      integer,
    max_count  integer,
    strategy   smallint
);

CREATE FUNCTION cc_destination_in(int4, int4, int8, int4, int4) RETURNS cc_destination
     AS 'MODULE_PATHNAME', 'cc_destination_in_args'
     LANGUAGE C IMMUTABLE CALLED ON NULL INPUT ;

CREATE FUNCTION cc_destination_id(cc_destination) RETURNS int4
     AS 'MODULE_PATHNAME', 'cc_destination_id'
     LANGUAGE C IMMUTABLE STRICT;

CREATE FUNCTION cc_destination_priority(cc_destination) RETURNS int4
     AS 'MODULE_PATHNAME', 'cc_destination_priority'
     LANGUAGE C IMMUTABLE STRICT;

CREATE FUNCTION cc_destination_type_id(cc_destination) RETURNS int4
     AS 'MODULE_PATHNAME', 'cc_destination_type_id'
     LANGUAGE C;


CREATE FUNCTION cc_dis_idle_agents(internal, int4) RETURNS internal
     AS 'MODULE_PATHNAME', 'cc_dis_idle_agents'
     LANGUAGE C ;

CREATE FUNCTION cc_dis_require_resources(anyarray, smallint, internal) RETURNS internal
     AS 'MODULE_PATHNAME', 'cc_dis_require_resources'
     LANGUAGE C ;

CREATE FUNCTION cc_dis_require_resources_agents(anyarray, smallint, internal) RETURNS internal
     AS 'MODULE_PATHNAME', 'cc_dis_require_resources_agents'
     LANGUAGE C ;

CREATE FUNCTION cc_test_recursion(
    req cc_sys_distribute_request,
    agents int4[],
    resources cc_sys_distribute_resource[],
    types cc_sys_distribute_type[]
) RETURNS setof record
     AS 'MODULE_PATHNAME', 'cc_test_recursion'
     LANGUAGE C;
